// ignore_for_file: omit_local_variable_types

import 'dart:io';

import 'package:pdfio/pdfio.dart';

void main() {
  final PdfDocument pdf = PdfDocument();
  final PdfPage page = PdfPage(pdf, pageFormat: const PdfPageFormat(500, 300));
  final PdfPage page1 = PdfPage(pdf, pageFormat: const PdfPageFormat(500, 300));

  pdf.pdfNames.addDest('target', page1, posY: 100);

  final PdfGraphics g = page.getGraphics();

  PdfAnnotation(
    page,
    const PdfAnnotText(
      rect: PdfRect(100, 100, 50, 50),
      content: 'Hello',
    ),
  );

  PdfAnnotation(
    page,
    const PdfAnnotNamedLink(
      dest: 'target',
      rect: PdfRect(100, 150, 50, 50),
    ),
  );
  g.drawRect(100, 150, 50, 50);
  g.strokePath();

  PdfAnnotation(
    page,
    const PdfAnnotUrlLink(
      rect: PdfRect(100, 250, 50, 50),
      url: 'https://github.com/DavBfr/dart_pdf/',
    ),
  );
  g.drawRect(100, 250, 50, 50);
  g.strokePath();

  final File file = File('build/annotations.pdf');
  file.writeAsBytesSync(pdf.save());
}
