library pdfio;

import 'dart:collection';
import 'dart:convert';
import 'dart:io';
import 'dart:math' as math;
import 'dart:typed_data';

import 'package:alm/alm.dart';
import 'package:image/image.dart' as im;
import 'package:meta/meta.dart';
import 'package:path_parsing/path_parsing.dart';
import 'package:utf/utf.dart';
import 'package:vector_math/vector_math_64.dart';

part 'src/graph/PdfAnnotation.dart';
part 'src/font/PdfArabic.dart';
part 'src/PdfArrayObject.dart';
part 'src/codec/ascii85.dart';
part 'src/graph/PdfBorder.dart';
part 'src/PdfCatalog.dart';
part 'src/graph/PdfColor.dart';
part 'src/graph/colors.dart';
part 'src/types/types.dart';
part 'src/document.dart';
part 'src/image/exif.dart';
part 'src/font/font.dart';
part 'src/font/font_descriptor.dart';
part 'src/font/font_metrics.dart';
part 'src/formxobject.dart';
part 'src/graph/function.dart';
part 'src/graph/graphic_state.dart';
part 'src/graph/graphics.dart';
part 'src/image/image.dart';
part 'src/info.dart';
part 'src/names.dart';
part 'src/object.dart';
part 'src/object_stream.dart';
part 'src/outline.dart';
part 'src/output.dart';
part 'src/page.dart';
part 'src/page_format.dart';
part 'src/page_list.dart';
part 'src/PdfPoint.dart';
part 'src/graph/rect.dart';
part 'src/graph/shading.dart';
part 'src/stream.dart';
part 'src/font/ttf_parser.dart';
part 'src/font/ttf_writer.dart';
part 'src/font/ttffont.dart';
part 'src/font/type1_font.dart';
part 'src/font/type1_fonts.dart';
part 'src/unicode_cmap.dart';
part 'src/xobject.dart';
part 'src/xref.dart';
