part of pdfio;

class PdfDocument {
  PdfDocument({bool compress = true}) {
    _objser = 1;
    // Now create some standard objects
    pdfPageList = PdfPageList(this);
    pdfNames = PdfNames(this);
    catalog = PdfCatalog(this, pdfPageList, pdfNames);
    info = PdfInfo(this);
  }

  int _objser;

  final Set<PdfObject> objects = <PdfObject>{};

  PdfCatalog catalog;

  PdfInfo info;

  PdfPageList pdfPageList;

  PdfNames pdfNames;

  PdfOutline _outline;
  PdfObject defaultOutlineBorder;
  PdfGraphicStates _graphicStates;
  final String version = '1.3';

  final Set<PdfFont> fonts = <PdfFont>{};

  Uint8List _documentID;

  Uint8List get documentID {
    _documentID ??= Uint8List.fromList(Alm.randomString(32).codeUnits);
    return _documentID;
  }

  int _genSerial() => _objser++;

  PdfPage page(int page) {
    return pdfPageList.getPage(page);
  }

  PdfOutline get outline {
    if (_outline == null) {
      _outline = PdfOutline(this);
      catalog.outlines = _outline;
    }
    return _outline;
  }

  PdfGraphicStates get graphicStates {
    _graphicStates ??= PdfGraphicStates(this);
    return _graphicStates;
  }

  bool get hasGraphicStates => _graphicStates != null;

  void _write(PdfStream os) {
    final PdfOutput pos = PdfOutput(os);
    objects.forEach(pos.write);
    pos.close();
  }

  Uint8List save() {
    final PdfStream os = PdfStream();
    _write(os);
    return os.output();
  }
}
