

part of pdfio;

class PdfInfo extends PdfObject {
  /// @param title Title of this document
  PdfInfo(PdfDocument pdfDocument,
      {this.title,
      this.author,
      this.creator,
      this.subject,
      this.keywords,
      this.producer})
      : super(pdfDocument, null) {
    if (author != null) {
      params['/Author'] = PdfString.fromString(author);
    }
    if (creator != null) {
      params['/Creator'] = PdfString.fromString(creator);
    }
    if (title != null) {
      params['/Title'] = PdfString.fromString(title);
    }
    if (subject != null) {
      params['/Subject'] = PdfString.fromString(subject);
    }
    if (keywords != null) {
      params['/Keywords'] = PdfString.fromString(keywords);
    }
    if (producer != null) {
      params['/Producer'] = PdfString.fromString('$producer ($_libraryName)');
    } else {
      params['/Producer'] = PdfString.fromString(_libraryName);
    }
    params['/CreationDate'] = PdfString.fromDate(DateTime.now());
  }

  static const String _libraryName = 'Alm@BBYS';

  final String author;

  final String creator;

  final String title;

  final String subject;

  final String keywords;

  final String producer;
}
