part of pdfio;

class PdfObject {
  PdfObject(this.pdfDocument, [String type])
      : assert(pdfDocument != null),
        objser = pdfDocument._genSerial() {
    if (type != null) {
      params['/Type'] = PdfName(type);
    }
    pdfDocument.objects.add(this);
  }

  final PdfDict params = PdfDict();

  final int objser;

  final int objgen = 0;

  final PdfDocument pdfDocument;

  void _write(PdfStream os) {
    _prepare();
    _writeStart(os);
    _writeContent(os);
    _writeEnd(os);
  }

  /// Prepare the object to be written to the stream
  @mustCallSuper
  void _prepare() {}

  void _writeStart(PdfStream os) {
    os.putString('$objser $objgen obj\n');
  }

  void _writeContent(PdfStream os) {
    if (params.isNotEmpty) {
      params.output(os);
      os.putString('\n');
    }
  }

  void _writeEnd(PdfStream os) {
    os.putString('endobj\n');
  }

  PdfIndirect ref() => PdfIndirect(objser, objgen);
}
